<template>
  <main>
    <mt-page-title :link-to="{ name: 'profil-dashboard-utilisateurs' }" link-text="Annuler">
      <h1 class="has-text-weight-bold is-size-3">création d'un utilisateur</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-champs-form-utilisateur
        :utilisateur="utilisateur"
        :corps="corps"
        :types-organismes="typesOrganismes"
        :organismes="organismes"
        :postes-ro="postesRo"
        :profils="profils"
        :type-organismes-allowed="typeOrganismesAllowed"
      />
      <div class="mt-fields-section">
        <h3 class="has-text-weight-bold">Mot de passe</h3>
        <div class="columns">
          <div class="column">
            <b-field label="Mot de passe">
              <b-input
                key="user-password"
                v-model="utilisateur.password"
                placeholder="Mot de passe"
                type="password"
                password-reveal
                required
                class="input-login"
              />
            </b-field>
          </div>
          <div class="column">
            <b-field label="confirmez le Mot de passe">
              <b-input
                key="user-password-confirmation"
                v-model="utilisateur.passwordconfirmation"
                placeholder="Mot de passe"
                type="password"
                password-reveal
                required
                class="input-login"
              />
            </b-field>
          </div>
        </div>
        <div class="control">
          <p v-if="erreur" class="help is-danger">{{ erreur }}</p>
        </div>
        <mt-password-security-meter :password="utilisateur.password" :rules="rules"></mt-password-security-meter>
      </div>
      <div class="columns is-centered">
        <b-button type="is-primary" native-type="submit" class="mt-button is-size-8">
          Créer l'utilisateur
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtChampsFormUtilisateur from '~/components/dashboard/utilisateur/champs-form-utilisateur';
import MtPasswordSecurityMeter from '~/components/connexion/password-security-meter';
import { newUtilisateur } from '~/components/mixins/utilisateurMixin';
import passwordRulesMixin from '~/components/mixins/passwordRulesMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtChampsFormUtilisateur,
    MtPasswordSecurityMeter,
  },
  mixins: [passwordRulesMixin],
  async asyncData(context) {
    const utilisateur = newUtilisateur();
    const isAdmin = context.store.getters['context/isAdmin'];
    const [typesOrganismes, corps] = await Promise.all([
      context.$api.typesOrganismes.allWithFirstChildOrganisme(),
      context.$api.corps.full(),
    ]);
    const userprofil = {
      id: null,
      profil: await context.$api.profils.getDefault(),
      selected: true,
    };
    utilisateur.userProfils.push(userprofil);
    let organismes = [typesOrganismes[0].organismes[0].id, 0, 0];
    typesOrganismes[1].organismes = await context.$api.organismes.organismesByParent(organismes[0]);
    typesOrganismes[1].organismes.unshift({ id: 0 });
    let idOrg = organismes[0];
    if (!isAdmin) {
      const unite = context.store.getters['context/organisme'];
      const idRegiment = unite.idparent;
      const regiment = await context.$api.organismes.get(idRegiment);
      organismes = [regiment.idparent, unite.idparent, unite.id];
      typesOrganismes[1].organismes = await context.$api.organismes.organismesByParent(regiment.idparent);
      typesOrganismes[2].organismes = await context.$api.organismes.organismesByParent(unite.idparent);
      idOrg = unite.id;
    }
    utilisateur.affectation.organisme.id = idOrg;
    const { content: postesRo } = await context.$api.postesRo.all(0, 50);
    const profils = await context.$api.utilisateurs.creationProfils();
    const typeOrganismesAllowed = await context.$api.typesOrganismes.typeOrganismesAllowed(
      context.store.getters['context/profil'],
    );
    return {
      utilisateur,
      corps,
      typesOrganismes,
      organismes,
      postesRo,
      profils,
      typeOrganismesAllowed,
      erreur: null,
    };
  },
  methods: {
    async submit() {
      try {
        if (this.utilisateur.password !== this.utilisateur.passwordconfirmation) {
          this.erreur = 'Les mots de passe doivent être identiques';
        } else {
          this.utilisateur.username = this.utilisateur.email;
          await this.$api.utilisateurs.post(this.utilisateur);
          this.$router.push({ name: 'profil-dashboard-utilisateurs' });
          this.$buefy.toast.open({
            message: `Création de l'utilisateur ${this.utilisateur.username} réussie !`,
            type: 'is-success',
          });
        }
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
/deep/ .security-level {
  margin-top: 0.5rem;
}
h3 {
  font-weight: bold;
  margin-bottom: 1rem;
  text-transform: uppercase !important;
}
</style>
